/* Copyright (c) 1996 by Groupe Bull. All Rights Reserved */
/* $Id: BoxLayoutDemo1.java,v 1.2 1996/06/18 08:31:26 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import java.awt.*;
import koala.misc.*;

public class BoxLayoutDemo1 {
    static public void main(String args[]) {
	Button b;
	Frame f = new Frame();
	HBoxLayout l = new HBoxLayout();
	f.setLayout(l);
	
	b = new Button("top-aligned");
	// we want a proportional space on left side
	l.setLeftHint(b, BoxLayout.PROPORTIONAL);
	// we want a proportional width
	l.setSizeHints(b, 1, 0);
	f.add(b);
	
	// we want a proportional space on left side
	b = new Button("justified");
	l.setLeftHint(b, BoxLayout.PROPORTIONAL)
	    // and we want proportional width and height.
	    .setSizeHints(b, BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL);
	f.add(b);

	
	b = new Button("bottom-aligned");
	//we want a proportional space on left, right and up sides.
	l.setLocationHints(b, BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL,
			   BoxLayout.PROPORTIONAL, BoxLayout.FIXED);
	// we want a proportional width, that is the 2 * others widths
	l.setWidthHint(b, BoxLayout.PROPORTIONAL * 2);
	f.add(b);

	f.pack();
	f.show();
    }
}
