/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: BoxLayoutDemo2.java,v 1.1 1996/06/18 08:31:27 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import java.awt.*;
import koala.misc.*;

public class BoxLayoutDemo2 {
    static public void main(String args[]) {
	Button b;
	Frame f = new Frame();
	VBoxLayout l = new VBoxLayout();
	f.setLayout(l);
	
	b = new Button("left-aligned");
 	// we want a proportional space on top and a proportional height
 	l.setTopHint(b, BoxLayout.PROPORTIONAL)
	    .setHeightHint(b, BoxLayout.PROPORTIONAL);
	f.add(b);
	
	// we want a proportional space on top
	b = new Button("justified");
 	l.setTopHint(b, BoxLayout.PROPORTIONAL)
 	    // and we want proportional width and height.
 	    .setSizeHints(b, BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL);
	f.add(b);

	
	b = new Button("right-aligned");
	//we want a proportional space on left, right and up sides.
 	l.setLocationHints(b, BoxLayout.PROPORTIONAL, BoxLayout.FIXED,
 			   BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL);
 	// we want a proportional height, that is the 2 * others widths
 	l.setHeightHint(b, BoxLayout.PROPORTIONAL * 2);
	f.add(b);

	f.pack();
	f.show();
    }
}
