/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: BoxLayoutDemo3.java,v 1.2 1996/06/18 08:31:28 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import koala.gui.*;
import koala.kit.*;
import koala.misc.*;
import koala.look.*;

// this example demonstrates how to use BoxLayout to achieve complex dynamic
// geometry managment. It builds a sample DialogBox, with a top area and two
// buttons. Well, it's not that simple, regarding to Tk's geometry managers,
// for example, but Tk's packer is not suited for interactive editing in UI
// builders. I believe this way of programming layouts is more builder-like.

public class BoxLayoutDemo3 {
    static public void main(String args[]) {
	Button b;
	Panel top, bottom;
	Frame f = new Frame();
	VBoxLayout framel = new VBoxLayout();
	f.setLayout(framel);

	top = new Panel();
	// top Panel will grow the entire width
	// I want its height to be 6 * bottom's.
	framel.setSizeHints(top, BoxLayout.PROPORTIONAL,
			    6 * BoxLayout.PROPORTIONAL);
	f.add(top);
	
	Separator s;
	f.add(s = new Separator());
	framel.setWidthHint(s, BoxLayout.PROPORTIONAL);

	
	bottom = new Panel();
	// bottom Panel will grow the entire width
	// its height will get the remaining space
	framel.setSizeHints(bottom, BoxLayout.PROPORTIONAL,
			    BoxLayout.PROPORTIONAL);
	HBoxLayout bottoml = new HBoxLayout(0, 0, 5);
	bottom.setLayout(bottoml);
	f.add(bottom);
	
	// The two buttons have to share bottom Panel proportionally
	b = new Button("  OK  ", null);
 	bottoml.setLocationHints(b, 1, 1, 1, 1)
	    .setSizeHints(b, BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL);
	bottom.add(b);
	
	b = new Button("Cancel", null);
 	bottoml.setLocationHints(b, 1, 1, 1, 1)
	    .setSizeHints(b, BoxLayout.PROPORTIONAL, BoxLayout.PROPORTIONAL);
	bottom.add(b);
	

	f.pack();
	f.resize(300, 200);
	f.show();
    }
}
