/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import koala.gui.*;
import koala.kit.*;
import koala.util.*;
import koala.look.*;

import java.awt.Component;
import java.awt.Event;
import java.awt.BorderLayout;

class ChangeToolCmd implements Command {
    String tool;
    DrawDemoWindow draw;
    public ChangeToolCmd(DrawDemoWindow d, String t) {
	draw = d;
	tool = t;
    }
    public void execute(Component c, Event ev) {
	System.out.println(tool);
	try {
	    draw.drawing.tool = (DrawingTool)Class.forName(tool).newInstance();
	}
	catch(Exception e) {
	    
	}
    }
}

class DrawDemoWindow extends Frame {
    DrawingPanel drawing;
    public DrawDemoWindow() {
	super();
	setLayout(new BorderLayout());
	setTitle("Java draw");
	
	drawing = new DrawingPanel();
	drawing.setTool(new VLine());
 	add("Center", drawing);
	
	makeMenus();
	makeToolbar();
    }
    
    void makeMenus() {
	
	Menu filem = new Menu(this);
	filem.addItem(new Button("New...", null));
	filem.addItem(new Button("Close...", null));
	filem.addItem(new Button("Open...", null));
	filem.addItem(new Button("Save...", null));
	filem.add(new Separator());
	filem.addItem(new Button("Exit...", new ExitCmd(0)));

	Menu editm = new Menu(this);
	editm.addItem(new Button("Cut", null));
	editm.addItem(new Button("Copy", null));
	editm.addItem(new Button("Paste", null));
	
 	MenuBar mbar = new MenuBar();
	mbar.addMenu(filem, "File");
	mbar.addMenu(editm, "Edit");
	add("North", mbar);
    }

    void makeToolbar() {
	Toolbar tbar = new Toolbar();
	tbar.setLayout(new VerticalLayout());
	String tools [] = {
	    "box", "line", "circle", "rounded"
	};
	String classes [] = {
	    "VRect", "VLine", "VCircle", "VRoundRect"
	};
	for(int i = 0; i < tools.length; i++) {
	    Button b =
		new Button(new Icon(this, "Tool_" + tools[i] + ".gif"),
			   new ChangeToolCmd(this, classes[i]));
	    b.setBehavior(null); // I'm not sure the Toolbar should do this
	    tbar.add((ButtonWidget)b);
	}
	add("West", tbar);
	pack();
	show();
    }
}

public class DrawDemo extends java.applet.Applet {
    static public void main(String args[]) {
	new DrawDemoWindow();
    }
    public void init() {
	DrawDemo.main(null);
    }
}
