/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import koala.gui.*;
import koala.util.*;
import java.awt.Dimension;

public class VLine implements DrawingTool {
    
    Dimension size;

    public VLine() {
	size = new Dimension(10, 10);
    }

    public VLine(Dimension s) {
	size = s;
    }

    public VLine(int w, int h) {
	size = new Dimension(w, h);
    }
    
    //============================================================
    //      implements: Look
    //============================================================

    public void draw(DrawingContext dc) {
	dc.drawLine(0, 0, size.width, size.height);
    }
    
    public Dimension request(DrawingContext dc) {
	return size;
    }
    
    public Dimension size(DrawingContext dc) {
	return size;
    }
    //============================================================
    //      implements: Feedback
    //============================================================

    public void drawFeedback(DrawingContext dc, int ox, int oy, int x, int y) {
	java.awt.Graphics gc = dc.graphics();
	gc.setXORMode(dc.style().background);
	gc.setColor(java.awt.Color.red);
	gc.drawLine(ox, oy, x, y);
    }
    public void eraseFeedback(DrawingContext dc, int ox, int oy, int x, int y){
	drawFeedback(dc, ox, oy, x, y);
    }
    //============================================================
    //      implements: DrawingTool
    //============================================================

    public void newInstance(ToolConsumer c, int ox, int oy, int x, int y) {
	int w = x-ox;
	int h = y-oy;
	c.add(ox, oy, new VLine(w, h));
    }

}
