/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import koala.gui.*;
import koala.util.*;
import java.awt.Dimension;

public class VRect implements DrawingTool {
    
    Dimension size;

    public VRect() {
	size = new Dimension(10, 10);
    }
    public VRect(Dimension s) {
	size = s;
    }

    public VRect(int w, int h) {
	size = new Dimension(w, h);
    }
    
    //============================================================
    //      implements: Look
    //============================================================

    public void draw(DrawingContext dc) {
	dc.drawRect(0, 0, size.width, size.height);
    }
    
    public Dimension request(DrawingContext dc) {
	return size;
    }
    
    public Dimension size(DrawingContext dc) {
	return size;
    }
    //============================================================
    //      implements: Feedback
    //============================================================

    public void drawFeedback(DrawingContext dc, int ox, int oy, int x, int y) {
	int w = Math.abs(x-ox);
	int h = Math.abs(y-oy);
	java.awt.Graphics gc = dc.graphics();
	gc.setXORMode(dc.style().background);
	gc.setColor(java.awt.Color.red);
	gc.drawRect(Math.min(ox, x), Math.min(oy, y), w, h);
    }
    public void eraseFeedback(DrawingContext dc, int ox, int oy, int x, int y){
	drawFeedback(dc, ox, oy, x, y);
    }
    //============================================================
    //      implements: DrawingTool
    //============================================================

    public void newInstance(ToolConsumer c, int ox, int oy, int x, int y) {
	int w = Math.abs(x-ox);
	int h = Math.abs(y-oy);
	c.add(Math.min(ox, x), Math.min(oy, y), new VRect(w, h));
    }

}
