/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: menubar.java,v 1.8 1996/06/12 15:39:22 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

import koala.gui.*;
import koala.kit.*;
import koala.util.*;
import koala.look.*;

public class menubar {

    static Menu makeMenu(Frame f, String names[]) {
	Menu m = new Menu(f);
	
	for(int i = 0; i < names.length; i++) {
	    Button b = new Button(names[i], new PrintCmd(names[i]));
	    m.addItem(b);
	}
	return m;
	
    }
    static public void main(String args[]) {
	Frame f = new Frame();
	Button b;
	
	String files [] = {
	    "Open", "Save", "Exit"
	};
	String edits [] = {
	    "Undo", "Cut", "Copy", "Paste"
	};
	String views [] = {
	    "Reload", "Refresh"
	};
	String options [] = {
	    "General Preferences", "Refresh"
	};
	String helps [] = {
	    "About", "Context help"
	};
	String encodings [] = {
	    "User Defined", "ISO Latin 1"
	};

	Menu filem = makeMenu(f, files);
	Menu editm = makeMenu(f, edits);
	Menu viewm = makeMenu(f, views);
	Menu optionm = makeMenu(f, options);
	Menu helpm = makeMenu(f, helps);
	
 	MenuBar mbar = new MenuBar();
	mbar.addMenu(filem, "File");
	mbar.addMenu(editm, "Edit");
	mbar.addMenu(viewm, "View");
	mbar.addMenu(optionm, "Options");
	mbar.addMenu(helpm, "Help");

	Button d = new Button("Disabled", (Command)null);
	d.disable();
	viewm.addItem(d);
	viewm.addItem(new Button("Enabled", (Command)null));
	viewm.addItem(new CheckButton("Bold", (Command)null));
	viewm.addItem(new CheckButton("Italic", (Command)null));
	viewm.addItem(new CheckButton("Underlined", (Command)null));

	helpm.addItem(new Button("A Propos", (Command)null));

	Menu encodingm = makeMenu(f, encodings);
	optionm.addMenu(encodingm, "Encodings");
	f.add("North", mbar);
 	f.validate();
 	f.pack();
 	f.show();
    }
}
