/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Activation.java,v 1.1 1996/06/05 15:34:46 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.gui;

import java.awt.Event;

/** 
 * This interface must be implemented by widgets that may be activated (for
 * example Buttons.
 */
public interface Activation {

   /**
    * <bold>ACTION</bold>: invoked when an activation is received on a widget.
    * 
    * @param what The widget that is activated.
    * @param e The AWT Event that triggered the action.
    */    
    public void activate(Widget what, Event e);

   /**
    * Add a Command that is executed everytime an activation occurs.
    */    
    public void onActivate(Command c);

   /**
    * Remove a Command from the Command lis.
    */    
    public void offActivate(Command c);
}
