/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Behavior.java,v 1.2 1996/05/21 16:09:40 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.gui;

import java.awt.Component;
import java.awt.Event;

/** 
 * Defines the interface for classes that know how to handle Events.
 *
 * @version	1.0 - jml - 3/13/96.
 */
public interface Behavior {
    
    /**
     * Handles the event. Returns true if the event is handled
     * false otherwise. and
     * @param evt the event to dispatch
     * @param c the component targeted by this event
     */
    public boolean handleEvent(Component c, Event evt);
}
