/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: D2Scrollee.java,v 1.2 1996/06/03 16:34:30 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.gui;

import koala.util.*;


/**
 * The Plane 2D Scrollee interface.
 *
 * Though the Scrolle interface may handle any number a scrolls, a common use
 * is to have a scrollee that uses the horizontal and vertical axes.
 *
 * These kind of scrolle are used by some Composite like ScrolledWindow that
 * automatically attach scrollees to scrollbars.
 */
public interface D2Scrollee extends Scrollee {

   /**
    * Should return the adjustement used as horizontal referee.
    */    
    Adjustment getHorizontalReferee();

   /**
    * Should return the adjustement used as vertical referee.
    */    
    Adjustment getVerticalReferee();
}
