/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: GrabManager.java,v 1.4 1996/06/03 09:09:13 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.gui;

import koala.util.Symbol;

import java.awt.Event;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Insets;
import java.util.Vector;


public class GrabManager implements EventFilter {
    Vector wins = new Vector();
    
    public void addGrab(Popup w) {
	wins.addElement(w);
    }
    
    public void removeGrab(Popup w) {
	wins.removeElement(w);

    }

    public Point rootCoords(Point pc, Component c) {
	Point coords = new Point(pc.x, pc.y);
	for(Component p = c; p != null; p = p.getParent()) {
	    coords.translate(p.location().x, p.location().y);
	    if(p.getParent() == null) {
		Insets i = ((Container)p).insets();
		coords.translate(- i.left, -i.top);
	    }
	}
	return coords;
    }

    public Popup locate(Point c) {
	for(int i = 0; i < wins.size(); i++) {
	    Popup w = (Popup)wins.elementAt(i);
	    if(w.bounds().inside(c.x, c.y)) {
		return w;
	    }
	}
	return null;
    }

    static Popup handler = null;
    public boolean handleEvent(Component c, Event e) {
	if(wins.size() == 0) return false;
	Point rootp = rootCoords(new Point(e.x, e.y), (Component)e.target);
	Popup w;
	boolean result = false;
	w = locate(rootp);
	if(w != handler) {
	    if(handler != null) {
		handler.lostGrab(w);
	    }
	    if(w != null) {
		w.gotGrab(handler);
	    }
	}
	handler = w;
 	if(w != null) {
 	    e.x = rootp.x - w.location().x;
 	    e.y = rootp.y - w.location().y;
 	    e.target = w;
 	    result =  w.handleEvent(e); 
 	}
	return result;
    }
}
