/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Popup.java,v 1.2 1996/05/31 13:07:34 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.gui;

import koala.util.*;
import java.awt.Component;
import java.awt.Event;
import java.awt.Point;
import java.awt.Insets;
import java.awt.Container;

abstract public class Popup extends Window {
    Command popup = null;
    Command popdown = null;
    
    public Popup(Frame parent) {
	super(parent);
    }

    public Popup onPopup(Command cmd) {
	popup = WidgetCode.onCommand(popup, cmd);
	return this;
    }

    public Popup onPopdown(Command cmd) {
	popdown = WidgetCode.onCommand(popdown, cmd);
	return this;
    }

    public Popup offPopup(Command cmd) {
	popup = WidgetCode.offCommand(popup, cmd);
	return this;
    }

    public Popup offPopdown(Command cmd) {
	popdown = WidgetCode.offCommand(popdown, cmd);
	return this;
    }

    public void show() {
	Toolkit.addGrab(this);
	super.show();
	if(popup != null) {
	    popup.execute(null, null);
	}
    }

    public void hide() {
	super.hide();
	Toolkit.removeGrab(this);

	if(popdown != null) {
	    popdown.execute(null, null);
	}
    }
    
    abstract public void gotGrab(Popup previous);
    abstract public void lostGrab(Popup next);
}
