/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: CascadeButton.java,v 1.6 1996/06/12 15:39:27 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.util.*;
import koala.gui.*;
import koala.look.*;

import java.awt.Event;
import java.awt.Component;

class CascadeReleaseCmd implements Command {
    CascadeButton target;
    public CascadeReleaseCmd(CascadeButton c) {
	target = c;
    }

    public void execute(Component c, Event evt) {
	target.release((Widget)c, evt);
    }
}

class CascadeButton extends Button {
    Menu menu;
    
    public CascadeButton(String s, Menu m) {
	super(s, null);
	attach(m);
    }

    public void attach(Menu m) {
	menu = m;
	m.onPopdown(new CascadeReleaseCmd(this));
    }

    public void press(Widget w, Event e) {
	//	System.out.println("press " + this);
	super.press(w, e);
	MenuContainer parent = (MenuContainer)getParent();
	parent.postMenu(this, menu);
    }

    public void activate(Widget w, Event e) {
    }
    
    public void release(Widget w, Event e) {
	if(! isPressed()) return;
	//	System.out.println("release " + this);
	MenuContainer parent = (MenuContainer)getParent();
	if(menu.isVisible()) {
	    parent.unpostMenu(this, menu);
	}
	super.release(w, e);
	hide(); show();
    }
}
