/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: DragBehavior.java,v 1.1.1.1 1996/05/10 09:16:17 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.gui.*;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;

public class DragBehavior implements Behavior {
    protected Slider slider;
    protected int oldx, oldy;
    
    public DragBehavior(Slider s) {
	slider = s;
    }
    
    public boolean handleEvent(Component c, Event evt) {
	switch (evt.id) {
	    case Event.MOUSE_DOWN: 
	    {
		oldx = evt.x;
		oldy = evt.y;
		slider.select(oldx, oldy , evt);
		return true;
	    }
	    case Event.MOUSE_DRAG: 
	    {
		int dx, dy;
		dx = evt.x - oldx;
		dy = evt.y - oldy;
		slider.drag(dx, dy, evt);
		oldx = evt.x;
		oldy = evt.y;
		return true;
	    }
	    case Event.MOUSE_UP: 
	    {
		slider.drop(oldx, oldy, evt);
		return true;
	    }
	}
        return false;
    }
}
