/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: RadioBox.java,v 1.3 1996/05/29 16:35:22 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.gui.*;
import koala.look.*;
import java.awt.Component;

public class RadioBox extends Composite {
    
    static protected Style defStyle = new Style("RadioBox");
    
    ButtonGroup group;
    
    public RadioBox() {
	group = new ButtonGroup();
	setBehavior(new SelectBehavior(group));
	setLayout(new VerticalLayout());
	setLook(new BorderLook());
	setStyle(defStyle);
    }
    
    public RadioBox(ButtonGroup sg) {
	group = sg;
    }
    
    public Component add(ButtonWidget c) {
	group.add(c);
	c.setLook(new HBox().add(new RadioLook(c)).add(new LabelLook(c)));
	return super.add((Component)c);
    }
    
    public synchronized void remove(ButtonWidget c) {
	super.remove((Component)c);
	group.remove(c);
    }
}
