/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Scale.java,v 1.6 1996/06/12 15:39:29 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.gui.*;
import koala.util.*;
import koala.look.*;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Dimension;
import java.util.Observer;
import java.util.Observable;

public class Scale extends Thumb {
    
    static protected Style style = new Style("Scale");
    protected static int SLIDERSIZE = 
      Integer.getInteger("Scale.slidersize", 30).intValue();
    protected static int SLIDERWIDTH =  
      Integer.getInteger("Scale.sliderwidth", 14).intValue();

    Look thumb = null;

    int slidersize = -1;
    public int sliderSize() {
	if(thumb != null) {
	    DrawingContext dc =
		new DrawingContext(this, this.getGraphics(),
				   this.clipper(), this.getStyle());
	    Dimension d = thumb.request(dc);
	    return (orientation == HORIZONTAL) ? d.width : d.height;
// 	    if(slidersize == -1) {
// 		DrawingContext dc =
// 		    new DrawingContext(this, this.getGraphics(),
// 				       this.clipper(), this.getStyle());
// 		Dimension r = thumb.request(dc);
// 		slidersize = (orientation == HORIZONTAL) ? r.width : r.height;
// 	    }
//	    return slidersize;
	}
	else {
	    return SLIDERSIZE;
	}
    }

    public int sliderWidth() {
	if(thumb != null) {
	    DrawingContext dc =
		new DrawingContext(this, this.getGraphics(),
				   this.clipper(), this.getStyle());
	    Dimension d = thumb.request(dc);
	    return (orientation == HORIZONTAL) ? d.height : d.width;
	}
	else {
	    return SLIDERWIDTH;
	}
    }
    
    public Scale() {
	super(new ActiveAdjustment());
    }
    
    public Scale(int orient) {
	super(new ActiveAdjustment(), orient);
    }
    
    public Scale(Adjustment a, int orient) {
	super(a, orient);
    }
    
    public Scale(Adjustment a, int orient, Look t) {
	super(a, orient);
	thumb = t;
    }
    
    public Scale(int orient, Look t) {
	super(new ActiveAdjustment(), orient);
	thumb = t;
    }
    
    public void draw(DrawingContext dc) {
	Dimension clip = dc.size();
	int ssize = sliderSize();
	int spos = sliderPos();
	if(orientation == HORIZONTAL) {
  	    dc.drawRelief(1, (clip.height/2)-2, clip.width - 2, 2, 
  			  Relief.RAISED,
			  dc.style().shadowThickness);
	    if(thumb == null) {
		dc.fillRelief(spos, 0, ssize, 
			      clip.height-1, Relief.RAISED,
			      dc.style().shadowThickness);
	    }
	    else {
		dc.shrinkLeft(spos);
		thumb.draw(dc);
	    }
	}
	else {
	    dc.drawRelief((clip.width/2)-2, 1, 2, clip.height - 2, 
			  Relief.RAISED,
			  dc.style().shadowThickness);
	    if(thumb == null) {
		dc.fillRelief(0, spos,  
			      clip.width-1, ssize, Relief.RAISED, 
			      dc.style().shadowThickness);
	    }
	    else {
		dc.shrinkTop(spos);
		thumb.draw(dc);
	    }
	}
    }
}
