/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Separator.java,v 1.2 1996/06/18 13:44:46 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.look.*;
import koala.gui.*;


/**
 * The Separator widget class.
 *
 * A Separator is an output-only widget that draws a line. It may be HORIZONTAL
 * or VERTICAL.
 */
public class Separator extends Control {
    
    static public final int HORIZONTAL = 1;
    static public final int VERTICAL = 2;
    
    static private Style style = new Style("Separator");

   /**
    * Builds a new Separator widget.
    *
    * @param o separator's orientation: VERTICAL or HORIZONTAL
    */    
    public Separator(int o) {
	setStyle(style);
	setLook(new SeparatorLook(o));
	setBehavior(null);
    }

   /**
    * Builds a new Separator widget.
    *
    * orientation is set to HORIZONTAL.
    */
    public Separator() {
	this(HORIZONTAL);
    }
}
