/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Toolbar.java,v 1.4 1996/06/03 16:34:38 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.kit;

import koala.gui.*;
import koala.look.*;
import koala.util.*;
import java.awt.Component;
import java.util.Observer;
import java.util.Observable;

public class Toolbar extends Composite implements Observer {
    
    static protected Style defStyle = new Style("Toolbar");
    
    Command select;
    ButtonGroup group;
    
    public Toolbar() {
	group = new ButtonGroup();
	setBehavior(new SelectBehavior(group));
	setLayout(new HorizontalLayout());
	setLook(new BorderLook());
	setStyle(defStyle);
	group.addObserver(this);
    }
    
    public Toolbar(ButtonGroup sg) {
	group = sg;
    }
    
    public synchronized Component add(ButtonWidget c) {
	group.add(c);
	return super.add((Component)c);
    }
    
    public synchronized void remove(ButtonWidget c) {
	super.remove((Component)c);
	group.remove(c);
    }

    public Toolbar onSelect(Command c) {
	select = WidgetCode.onCommand(select, c);
	return this;
    }

    public Toolbar offSelect(Command c) {
	select = WidgetCode.offCommand(select, c);
	return this;
    }

    //============================================================
    //      implements: Observer
    //============================================================

    public void update(Observable obs, Object o) {
	WidgetCode.execute(select, this, null);
    }
}
