/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: ButtonLook.java,v 1.6 1996/06/12 15:39:31 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.look;

import koala.gui.*;
import koala.util.*;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Component;
import java.awt.Color;


public class ButtonLook implements Look {
    protected ButtonWidget target;
    protected BorderLook body;
    
    public ButtonLook(ButtonWidget bc) {
	target = bc;
	// we'll draw a centered label within a border
	body = new BorderLook(new HVCPlug(new LabelLook(target)));
    }
       
    public ButtonLook(ButtonWidget bc, Look l) {
	target = bc;
	body = new BorderLook(l);
    }
    
    public void draw(DrawingContext dc) {
	Style s = dc.style();
	int r = s.relief;
	s.relief = (target.isPressed()) ? Relief.SUNKEN : r;
	if(s.relief == Relief.SUNKEN) {
 	    dc.setColor(Relief.halfDarker(dc.style().background));
	    dc.fillRect(0, 0, dc.size().width, dc.size().height);
	    dc.setColor(s.foreground);
	}
	body.draw(dc);
	s.relief = r;
    }
    
    public Dimension request(DrawingContext dc) {
	return body.request(dc);
    }
    
    public Dimension size(DrawingContext dc) {
	return body.size(dc);
    }
}
