/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: CheckLook.java,v 1.2 1996/05/30 07:40:22 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */




package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Color;
import koala.gui.*;

public class CheckLook implements Look {
    static final int SIZE = Integer.getInteger(Gui.CHECK_SIZE, 10).intValue();
    static final Color ACTIVE_COLOR = 
        Color.getColor(Gui.CHECK_COLOR, Color.red);
    static final Dimension DIMENSION = new Dimension(SIZE, SIZE);
    
    protected ButtonWidget target;

    public CheckLook(ButtonWidget bc) {
	target = bc;
    }
       
    public void draw(DrawingContext dc) {
	int w, h, relief;
	Dimension clip = dc.size();

 	w = clip.width;
 	h = clip.height;
	relief = target.isPressed() ? Relief.SUNKEN : Relief.RAISED;
 	if(target.isPressed()) {
	    dc.setColor(ACTIVE_COLOR);
	    dc.fillRect(0, (h-SIZE)/2, SIZE, SIZE);
	}
	dc.setColor(dc.style().background);
	dc.drawRelief(0, (h-SIZE)/2, SIZE, SIZE, relief, 
		      dc.style().shadowThickness);
	dc.setColor(dc.style().foreground);
    }
    
    public Dimension request(DrawingContext dc) { 
	return DIMENSION;
    }
    
    public Dimension size(DrawingContext dc) { 
	return DIMENSION;
    }
}
