/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: HBox.java,v 1.6 1996/06/18 13:44:47 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */


package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import koala.gui.*;
import koala.util.*;

public class HBox extends Combinator {
    
    public HBox(int g, int m) {
	gap = g;
	margin = m;
    }
    
    public HBox() {
	super();
    }
    
    public synchronized void draw(DrawingContext pdc) {
	DrawingContext dc = new DrawingContext(pdc);
	dc.resize(dc.size().width, size.height);
	dc.shrink(gap, margin, gap, margin);
	for(int i = 0 ; i < children.size(); i++) {
	    Look l = (Look)children.elementAt(i);
	    l.draw(dc);
	    dc.shrinkLeft(l.size(dc).width + gap);
	}
    }
    
    public synchronized Dimension request(DrawingContext dc) {
	int n = children.size();
	size = new Dimension((gap* (n+1)), 0);
	Dimension r2;
	for(int i = 0 ; i < n; i++) {
	    r2 = ((Look)children.elementAt(i)).request(dc);
	    size.width += r2.width;
	    size.height = Math.max(r2.height, size.height);
	}
	size.height += margin*2;
	return size;
    }
}
