/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: LabelLook.java,v 1.3 1996/06/05 15:34:58 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */



package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Color;
import koala.gui.*;


public class LabelLook implements Look {
    protected LabelWidget target;
    Dimension size = null;
    
    public LabelLook(LabelWidget bc) {
	target = bc;
    }
       
    public void draw(DrawingContext dc) {
	int h;
	Graphics g = dc.graphics();
	Dimension clip = dc.size();
	
 	h = g.getFontMetrics().getHeight();
	if(! target.isEnabled()) {
	    g.setColor(Relief.grayed(dc.style().foreground));
	}
 	dc.drawString(target.getLabel(), 0,
 		     (clip.height-h)/2+g.getFontMetrics().getAscent());
	if(! target.isEnabled()) {
	    g.setColor(dc.style().foreground);
	}

    }
    
    public Dimension request(DrawingContext dc) {
	Graphics g = dc.graphics();

	FontMetrics fm = g.getFontMetrics();
	size =  new Dimension(fm.stringWidth(target.getLabel()), 
			      fm.getHeight()+6);
	return size;
    }
    
    public Dimension size(DrawingContext dc) {
	return (size != null) ? size : request(dc);
    }
}
