/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: RadioLook.java,v 1.3 1996/05/30 07:40:26 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Color;
import koala.gui.*;

public class RadioLook implements Look {
    static final int SIZE = 
            Integer.getInteger(Gui.ROUND_CHECK_SIZE, 11).intValue();
    static final Color ACTIVE_COLOR = 
      Color.getColor(Gui.CHECK_COLOR, Color.red);
    static final Dimension DIMENSION = new Dimension(SIZE, SIZE);
    static final int THICKNESS = 1;
    static final int GAP = 0;
    
    protected ButtonWidget target;

    public RadioLook(ButtonWidget bc) {
	target = bc;
    }
       
    public void draw(DrawingContext dc) {
	int w, h, relief;
	Dimension clip = dc.size();

 	w = clip.width;
 	h = clip.height;
	relief = target.isPressed() ? Relief.SUNKEN : Relief.RAISED;
 	if(target.isPressed()) {
	    dc.setColor(ACTIVE_COLOR);
	    dc.fillOval(GAP, GAP+(h-SIZE)/2, SIZE-GAP*2, SIZE-GAP*2);
	}
	dc.setColor(dc.style().background);
	dc.drawOvalShadow(0, (h-SIZE)/2, SIZE, SIZE, relief, THICKNESS);
	dc.setColor(dc.style().foreground);
    }
    
    public Dimension request(DrawingContext dc) { 
	return DIMENSION;
    }
    
    public Dimension size(DrawingContext dc) { 
	return DIMENSION;
    }
}
