/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: VBox.java,v 1.3 1996/06/18 13:44:47 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Graphics;
import koala.gui.*;



public class VBox extends Combinator {
    private int w, h;
    public synchronized void draw(DrawingContext pdc) {
	DrawingContext dc = new DrawingContext(pdc);
	dc.resize(size.width, dc.size().height);
	dc.shrink(margin, gap, margin, gap);
	for(int i = 0 ; i < children.size(); i++) {
	    Look l = (Look)children.elementAt(i);
	    l.draw(dc);
	    dc.shrinkTop(l.request(dc).width + gap);
	}
    }
    
    public synchronized Dimension request(DrawingContext dc) {
	int n = children.size();
	Dimension result = new Dimension(margin*2, (gap* (n+1)));
	Dimension r2;
	for(int i = 0 ; i < n; i++) {
	    r2 = ((Look)children.elementAt(i)).request(dc);
	    result.height += r2.height;
	    result.width = Math.max(r2.width, result.width);
	}
	w = result.width;
	h = result.height;
	return result;
    }
}
