/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: VisualString.java,v 1.1.1.1 1996/05/10 09:16:27 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.look;

import java.awt.Font;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Color;
import koala.gui.*;
import koala.util.*;


public class VString implements Look {
    protected String target;
    protected Style style = null;

    Dimension size = null;
    
    public VString(String s) {
	this(s, null);
    }
    
    public VString(String s, Style sty) {
	target = s;
	style = sty;
    }
    
    public void draw(DrawingContext dc) {
	App.debug("VString drawing into " + dc.size());
	if(style != null) dc.push(style);
 	dc.drawString(target, 0, dc.graphics().getFontMetrics().getAscent());
	if(style != null) dc.pop();
    }
    
    public Dimension request(DrawingContext dc) {
	Graphics g = dc.graphics();
	Style sty = (style != null) ? style : dc.style();

	FontMetrics fm = g.getFontMetrics(sty.font);
	size = new Dimension(fm.stringWidth(target), 
			       fm.getHeight());
	App.debug("VString requesting " + size);
	return size;
    }
    
    public Dimension size(DrawingContext dc) {
	return (size != null) ? size : request(dc);
    }
    
    public String toString() {
	return "'" + target + "'";
    }
}
