/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: ActiveBoolean.java,v 1.3 1996/06/18 16:12:20 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

/**
 * An active implementation of Boolean that notifies its changes to its
 * observers.
 */
public class ActiveBoolean extends Subject implements BooleanModel {
    protected boolean value = false;

   /**
    * Sets the new boolean value. Triggers the update method for attached
    * observers.
    */
    public void set(boolean v) {
	value = v;
	setChanged();
	notifyObservers();
    }

   /**
    * Returns the current value.
    */    
    public boolean get() {
	return value;
    }
}
