/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: ActiveInt.java,v 1.3 1996/06/18 16:12:21 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

/**
 * An active implementation of int that notifies its changes to its
 * observers.
 */
public class ActiveInt extends Subject implements IntegerModel {
    protected int value = 0;
    
   /**
    * Sets the new int value. Triggers the update method for attached
    * observers.
    */
    public void set(int v) {
	value = v;
	setChanged();
	notifyObservers();
    }
    
   /**
    * Returns the current value.
    */   
    public int get() {
	return value;
    }
}
