/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: ExitCmd.java,v 1.2 1996/06/05 15:35:00 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import koala.gui.*;

import java.awt.Event;
import java.awt.Component;

/**
 * A Command that terminates the application.
 */
public class ExitCmd implements Command {

   /**
    * A predefined ExtCmd with exit code = 0.
    */
    static public ExitCmd SUCCESS = new ExitCmd(0);

    private int exitCode;


   /**
    * builds a new ExitCmd, with the given exit code.
    * @param c exit code for this command.
    */    
    public ExitCmd(int c) {
	exitCode = c;
    }
    
   /**
    * Triggers the command.
    * @param e the Event that triggered the command
    * @param c the Component that received the event
    */    
    public void execute(Component c, Event e) {
	System.exit(exitCode);
    }
}

