/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.awt.Rectangle;
import java.awt.Dimension;

public class GeometryComputer implements GeometryManager {

    Rectangle boxes[];
    int lwidth = 0, lheight = 0;

    public GeometryComputer(Rectangle r[]) {
	boxes = r;
    }

    public void select(Rectangle s[]) {
	boxes = s;
    }

   /**
    * Expand width of objects to the largest's.
    */    
    public void expandWidth(int margin) {
	int width = java.lang.Integer.MIN_VALUE;       
	
	for(int i = 0; i < boxes.length; i++) {
	    width = Math.max(width, boxes[i].width+margin);
	}
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].width = width;
	}
	lwidth = width;
    }

   /**
    * Expand width of objects to the largest's.
    */    
    public void expandHeight(int margin) {
	int height = java.lang.Integer.MIN_VALUE;       
	
	for(int i = 0; i < boxes.length; i++) {
	    height = Math.max(height, boxes[i].height+margin);
	}
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].height = height;
	}
	lheight = height;
    }

   /**
    * Distribute objects horizontally.
    */    
    public void distributeHorizontally() {
	for(int i = 0; i < boxes.length; i++) {
	    lwidth += boxes[i].width;
	}
    }

    
    public void flushBottom(int margin) {
	lheight += margin;
    }

    
    public void flushTop(int margin) {
	lheight += margin;
    }

    public Dimension size() {
	return new Dimension(lwidth, lheight);
    }
}
