/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id:$ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.awt.Rectangle;
import java.awt.Dimension;

public class GeometryRenderer implements GeometryManager {

    Rectangle boxes[];
    int lwidth, lheight;

    public GeometryRenderer(Rectangle r[], int w, int h) {
	boxes = r;
	lwidth = w;
	lheight = h;
    }

    public void select(Rectangle s[]) {
	boxes = s;
    }
    
   /**
    * Expand width of objects to the largest's.
    */    
    public void expandWidth(int margin) {
	int width = java.lang.Integer.MIN_VALUE;       
	
	for(int i = 0; i < boxes.length; i++) {
	    width = Math.max(width, boxes[i].width+margin);
	}
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].width = width;
	}
    }


   /**
    * Expand width of objects to the largest's.
    */    
    public void expandHeight(int margin) {
	int height = java.lang.Integer.MIN_VALUE;       
	
	for(int i = 0; i < boxes.length; i++) {
	    height = Math.max(height, boxes[i].height+margin);
	}
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].height = height;
	}
    }

   /**
    * Distribute objects horizontally.
    */    
    public void distributeHorizontally() {
	int cwidth = 0;		// total width of children
	for(int i = 0; i < boxes.length; i++) {
	    cwidth += boxes[i].width;
	}
	int hgap = (lwidth-cwidth) / (boxes.length+1);
	int left = hgap;
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].x = left;
	    left += hgap + boxes[i].width;
	}
    }

    public void flushBottom(int margin) {
	int h = lheight - margin;
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].y = h - boxes[i].height;
	}
    }

    public void flushTop(int margin) {
	for(int i = 0; i < boxes.length; i++) {
	    boxes[i].y = margin;
	}
    }
}
