/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: HideCmd.java,v 1.3 1996/06/18 16:12:24 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import koala.gui.*;

import java.awt.Event;
import java.awt.Component;

/**
 * A common Command that calls hide() for its target.
 */
public class HideCmd implements Command {

    private Component obj;

   /**
    * Builds a new HideCmd.
    */    
    public HideCmd(Component c) {
	obj = c;
    }

   /**
    * calls the hide() method for the target object.
    */    
    public void execute(Component c, Event e) {
	obj.hide();
    }
}

