/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: NumericModel.java,v 1.3 1996/06/18 16:12:24 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.util.Observer;

/**
 * A Model that can be accessed via numeric values.
 * @see Model
 * @version	1.0 - jml - 3/26/96.
 */
public interface NumericModel extends Model {

   /**
    * Sets the model's value. This notifies changes to the observers.
    * @param v the new numeric value.
    */    
    public void set(float v);
    
   /**
    * Returns the model's value.
    */    
    public float get();

   /**
    * Increments model's value.
    */    
    public void inc();

   /**
    * Decrements model's value.
    */    
    public void dec();
}
