/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: SensitiveFormula.java,v 1.2 1996/06/18 13:44:52 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.awt.Component;
import java.util.Observable;

public class SensitiveFormula implements Formula {
    Component receiver;
    
    public SensitiveFormula(BooleanModel model, Component c) {
	model.addObserver(this);
	receiver = c;
	update((Observable)model, null); // This could be in the Formula const
    }
    
    public void update(Observable o, Object arg) {
	BooleanModel model = (BooleanModel)o;
	if(model.get()) {
	    receiver.enable();
	}
	else {
	    receiver.disable();
	}
	receiver.repaint();
    }

}
