/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: SequenceModel.java,v 1.4 1996/06/18 16:12:26 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.util.Enumeration;

public interface SequenceModel extends Model {
   /**
    * Inserts an item at position 'n'.
    */
    public void insert(int n, Object item);

   /**
    * Appends an item
    */
    public void insert(Object item);

   /**
    * Removes all items.
    */  
    public void removeAll();

   /**
    * Removes item at position 'n'.
    */
    public void remove(int n);

   /**
    * Removes an item.
    */
    public void remove(Object item);

   /**
    * Returns element at position 'n'.
    */  
    public Object elementAt(int n);

   /**
    * Returns an Enumeration of elements.
    */  
    public Enumeration elements();

   /**
    * Returns true if the elements is contained, false otherwise.
    */
    public boolean contains(Object item);

   /**
    * Returns the number of elements.
    */    
    public int size();
}
