/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: ShowCmd.java,v 1.4 1996/06/18 16:12:27 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import koala.gui.*;

import java.awt.Event;
import java.awt.Component;


/**
 * A common Command that calls show() for its target.
 */
public class ShowCmd implements Command {

    private java.awt.Window obj;

   /**
    * Builds a new ShowCmd.
    */    
    public ShowCmd(java.awt.Window c) {
	obj = c;
    }
    
   /**
    * calls the show() method for the target object.
    */    
    public void execute(Component c, Event e) {
	obj.resize(1, 1);
	obj.pack();
	obj.show();
    }
}

