/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: StringModel.java,v 1.1.1.1 1996/05/10 09:16:37 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */


package koala.util;

import java.util.Observer;


/**
 * A Model that can be accessed via String values.
 * @see Model
 * @version	1.0 - jml - 3/26/96.
 */
public interface StringModel extends Model {
    
   /**
    * Sets the model's value. This notifies changes to the observers.
    * @param v the new string value.
    */    
    public void set(String v);

   /**
    * Returns the model's value.
    */    
    public String get();
}
