/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Subject.java,v 1.3 1996/06/18 16:12:27 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

import java.util.*;

/**
 * A Sample implementation of the Model interface.
 */
public class Subject extends Observable implements Model {
    protected boolean update = true;

    
   /**
    * disables update notification.
    */   
    public void disable() {
	update = false;
    }
    
   /**
    * enables update notification. It calls notifyObservers, so that is the
    * model was modified it updates observers now.
    */
    public void enable() {
	update = true;
	notifyObservers();
    }

    public void notifyObservers() {
	if(update) {
	    super.notifyObservers();
	}
    }
}
