/* Copyright (c) 1996 by Groupe Bull.  All Rights Reserved */
/* $Id: Symbol.java,v 1.2 1996/06/18 16:12:28 leon Exp $ */
/* Author: Jean-Michel.Leon@sophia.inria.fr */

package koala.util;

/**
 * A Symbol is an association between a String and an int value.
 */
public class Symbol {
    public String name;
    public int id;

   /**
    * Builds a new Symbol named 'n', with value 'v'.
    */
    public Symbol(String n, int v) {
	name = n;
	id = v;
    }

   /**
    * Searches for a Symbolic property.
    *
    * if a property 'name' exists and if its value is a known Symbol in
    * 'values', it returns symbol's value; else it returns 'def'.
    */
    static public int getSymbol(String name, Symbol values[], int def) {
	try {
	    String v = System.getProperty(name, "");
	    for(int i = 0; i < values.length; i++) {
		if(values[i].name.equals(v)) {
		    return values[i].id;
		}
	    }
	    if(! v.equals("")) {
		App.warning("incorrect value (" + v + ") for symbol '" +
			    name +"'");
	    }
	}
	catch(SecurityException e) {
	}
	return def;
    }
}
